Imports Microsoft.VisualBasic
Imports System
Imports System.Windows
Imports System.Windows.Controls
Imports Samples


Namespace DynamicXap
	Partial Public Class Page
		Inherits UserControl
		Private content As UIElement = Nothing
		Private item As TabItem = Nothing

		Public Sub New()
			InitializeComponent()
		End Sub


		Private Sub chkNewContent_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Dim shouldDisplay As Boolean = (TryCast(sender, CheckBox)).IsChecked.Value ' IsChecked is nullable<bool>

			If shouldDisplay Then
				If (Not IsContentAvailable()) Then
					DownloadContent()
				Else
					ShowContent()
				End If
			Else
				HideContent()
			End If
		End Sub

		Private Function IsContentAvailable() As Boolean
			Return (content IsNot Nothing)
		End Function

		Private Sub DownloadContent()
			Dim dl As New Downloader()
			AddHandler dl.XapDownloaded, AddressOf dl_PackageDownloaded
			dl.LoadPackage("more.xap", "more.dll", "More.ExtraTab")
		End Sub

		Private Sub dl_PackageDownloaded(ByVal sender As Object, ByVal e As XapEventArgs)
			content = e.DownloadedContent
			ShowContent()
		End Sub

		Private Sub HideContent()
			Me.TabList.Items.Remove(item)
		End Sub

		Private Sub ShowContent()
			item = New TabItem()
			item.Header = "Extra tab"
			item.Content = content
			Me.TabList.Items.Add(item)
		End Sub
	End Class
End Namespace
