Imports Microsoft.VisualBasic
Imports System
Imports System.Windows.Controls
Imports System.Net
Imports System.Reflection
Imports System.IO
Imports System.Windows
Imports System.Windows.Resources


Namespace Samples
	Public Class XapEventArgs
		Inherits EventArgs
		Public DownloadedContent As UserControl
	End Class


	Public Class Downloader
		#Region "Local members"
		Private assemblyName As String
		Private className As String
		#End Region

		Public Event XapDownloaded As EventHandler(Of XapEventArgs)

		Public Sub LoadPackage(ByVal xap As String, ByVal asm As String, ByVal cls As String)
			assemblyName = asm
			className = cls

			Dim address As New Uri(xap, UriKind.RelativeOrAbsolute)
			Dim client As New WebClient()
			AddHandler client.OpenReadCompleted, AddressOf OnCompleted
			client.OpenReadAsync(address)
		End Sub


		#Region "Helpers"

		Private Sub OnCompleted(ByVal sender As Object, ByVal e As OpenReadCompletedEventArgs)
			If XapDownloadedEvent Is Nothing Then
				Return
			End If

			If e.Error IsNot Nothing Then
				Return
			End If

			' Load a particular assembly from XAP
			Dim a As System.Reflection.Assembly = GetAssemblyFromPackage(assemblyName, e.Result)

			' Get an instance of the XAML object
			Dim page As Object = a.CreateInstance(className)

			' Fire the event
			Dim args As New XapEventArgs()
			args.DownloadedContent = TryCast(page, UserControl)
			RaiseEvent XapDownloaded(Me, args)
		End Sub

		Private Function GetAssemblyFromPackage(ByVal assemblyName As String, ByVal xapStream As Stream) As System.Reflection.Assembly
			' Local variables
			Dim assemblyUri As Uri = Nothing
			Dim resPackage As StreamResourceInfo = Nothing
			Dim resAssembly As StreamResourceInfo = Nothing
			Dim part As AssemblyPart = Nothing

			' Initialize
			assemblyUri = New Uri(assemblyName, UriKind.Relative)
			resPackage = New StreamResourceInfo(xapStream, Nothing)
			resAssembly = Application.GetResourceStream(resPackage, assemblyUri)

			' Extract an assembly 
			part = New AssemblyPart()
			Dim a As System.Reflection.Assembly = part.Load(resAssembly.Stream)
			Return a
		End Function

		#End Region    
	End Class
End Namespace
